C                        PROGRAM GWSIM - IV
C                  GROUND WATER SIMULATION PROGRAM 
C                TEXAS DEPARTMENT OF WATER RESOURCES
C  
C                               BY 
C                           TOMMY KNOWLES  
C                DATA COLLECTION AND EVALUATION SECTION
C                DATA AND ENGINEERING SERVICES DIVISION
C***********************************************************************
      COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE, 
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25),KSSH,KQUAL
      COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     1(100),G(100),SUMS(18,2), 
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE
     1,TITMOD(20),VFMT(20,7)
      INTEGER OPT,FLAG,OUT,OUT1
C***********************************************************************
C     THE FOLLOWING CARDS MUST BE CHANGED IF THE FINITE DIFFERENCE GRID
C     CONTAINS MORE THAN 31 ROWS OR 31 COLUMNS 
C***********************************************************************
      PARAMETER (NROW=31,NCOL=80)
      DIMENSION FLAG(NROW,NCOL),BOTLEL(NROW,NCOL),H(NROW,NCOL),
     1HO(NROW,NCOL),P(NROW,NCOL,2),SF1(NROW,NCOL),T(NROW,NCOL,2),  
     1 THIK(NROW,NCOL), QSUM(NROW,NCOL),
     2Q(NROW,NCOL),RHG(NROW,NCOL),DL(NROW,NCOL)
     1,R(NROW,NCOL),RD(NROW,NCOL),TOPAQ(NROW,NCOL),SURF(NROW,NCOL) 
     1,HDUM(NROW,NCOL) 
C***********************************************************************
      DIMENSION DUM1(2), DUM2(2)
      EQUIVALENCE (DUM1(2),B(1)), (DUM2(2),G(1))
      DUM1(1)=0.0  
      DUM2(1)=0.0  
C***********************************************************************
C     DEFINE INPUT AND OUTPUT DEVICE NUMBERS
C***********************************************************************
      IN=7 
      OPEN(UNIT=7,FILE='input',STATUS='OLD')
      IN1=11
      OPEN(UNIT=11,FORM='UNFORMATTED',STATUS='scratch')
      IN2=12
      OPEN(UNIT=12,FORM='UNFORMATTED',STATUS='scratch')
      IN3=13
      OPEN(UNIT=13,FORM='UNFORMATTED',STATUS='scratch')
      IN4=14
      OPEN(UNIT=14,FORM='UNFORMATTED',STATUS='scratch')
      IN5=15
      OPEN(UNIT=15,FORM='UNFORMATTED',STATUS='SCRATCH')
      IN6=16
      OPEN(UNIT=16,FORM='UNFORMATTED',STATUS='SCRATCH')
      OUT=8
      OPEN(UNIT=8,FILE='modout',STATUS='UNKNOWN')
      OUT1=10 
      OPEN(UNIT=10,FILE='modout2',STATUS='UNKNOWN') 
C***********************************************************************
C     READ TITLE CARD AND  
C     READ PARAMETER CARD  
C***********************************************************************
      READ (IN,650) TITLE  
      WRITE(OUT,710) TITMOD,TITLE  
      READ (IN,520) NSTEPS,NSP,NR,NC,NPARM 
     1,NSPRG
      READ (IN,530) DELMAJ,ERROR,TIMACL,PMPFCT,PMPNAM,XLGTNM,FLXNAM,PERF
     1CT,FLXFCT,STRFCT 
     1,SCALE
C***********************************************************************
C     CALCULATE SIZE OF FIRST MINOR TIME STEP  
C***********************************************************************
      DELTA=1.0
      N=NSP
   10 N=N-1
      IF (N) 30,30,20  
   20 DELTA=DELTA+TIMACL**N
      GO TO 10 
   30 DELTA=DELMAJ/DELTA
      WRITE (OUT,660) NSTEPS,NSP,DELMAJ,DELTA,ERROR,NC,NR,NPARM,NSPRG,S
     1TRFCT,TIMACL,PMPFCT,PMPNAM,PERFCT,FLXFCT,FLXNAM,XLGTNM
C***********************************************************************
C      READ PHYSICAL DATA  
C***********************************************************************
      CALL PHYSDT(NROW,NCOL,FLAG,BOTLEL,H,HO,P,SF1,T,THIK,SURF,
     1TOPAQ,R,RD)  
   40 TIME=0.0 
      NBLK=1
      IRWC(1,1)=1  
      IRWC(2,1)=NR 
      IRWC(3,1)=1  
      IRWC(4,1)=NC 
      TIMAC2=TIMACL
      DELMJ2=DELMAJ
      DEL=DELTA
C***********************************************************************
C      CALCULATE ITERATION PARAMETERS  
C***********************************************************************
      HA=2.
      HC=3.14159*3.14159/(2*NR*NR) 
      HB=3.14159*3.14159/(2*NC*NC) 
      DO 50 I=1,NR 
      DO 50 J=1,NC 
      IF (FLAG(I,J).GT.2) GO TO 50 
      HF=DELX(J)*DELX(J)/(DELY(I)*DELY(I)) 
      HD=HB/(1.+HF)
      F=HC/(1.+1./HF)  
      HA=AMIN1(HA,HD,F)
   50 CONTINUE 
      F=EXP(ALOG(1./HA)/(NPARM-1)) 
      PRMITR(1)=HA 
      DO 60 I=2,NPARM  
   60 PRMITR(I)=PRMITR(I-1)*F  
      WRITE (OUT,510) (PRMITR(I),I=1,NPARM)
      TIME1=0. 
C***********************************************************************
C     BEGIN MAJOR TIME STEP LOOP
C***********************************************************************
      DO 490 ISTEP=1,NSTEPS
      WRITE(OUT,710)TITMOD,TITLE
      WRITE (OUT,720) ISTEP
      DELTA=DEL
      NSP1=NSP 
      DELMAJ=DELMJ2
      TIMACL=TIMAC2
C***********************************************************************
C     READ OPTIONS FOR THIS TIME STEP  
C***********************************************************************
      READ (IN,670) OPT,NSP2,DELMJ1,TIMAC1 
     1,(B(J),J=1,6)
      WRITE (OUT,680) (B(J),J=1,6) 
      IF(OPT(14).GT.0.OR.OPT(15).GT.0) KOUT1=1 
      DO 70 I=1,30 
      IF (OPT(I).GT.0) WRITE (OUT,550) I,OPT(I)
      IF (OPT(1).GT.0.AND.I.EQ.1) WRITE (OUT,690) NSP2,DELMJ1,TIMAC1
   70 CONTINUE 
   80 CONTINUE 
      NSP1=NSP 
      IF (OPT(1).LT.1) GO TO 120
C***********************************************************************
C      ADJUST TIME STEP PARAMETERS 
C***********************************************************************
      TIMACL=TIMAC1
      DELTA=1. 
      N=NSP2
   90 N=N-1
      IF (N) 110,110,100
  100 DELTA=DELTA+TIMACL**N
      GO TO 90 
  110 DELTA=DELMJ1/DELTA
      NSP1=NSP2
      DELMAJ=DELMJ1
  120 CONTINUE 
      DO 130 I=1,16
      SUMS(I,1)=0. 
      IF(ISTEP.EQ.1)SUMS(I,2)=0.
  130 CONTINUE 
      DO 140 I=1,NR
      DO 140 J=1,NC
  140 QSUM(I,J)=0.0
C***********************************************************************
C       READ EXTERNAL FLUX (PUMPAGE AND RECHARGE)  
C***********************************************************************
      CALL GETPMP(NROW,NCOL,FLAG,Q,RHG)
C***********************************************************************
C      READ ENDING HEADS FOR CONSTANT-HEAD CELLS
C***********************************************************************
      IF (OPT(24).LT.1) GO TO 210  
      WRITE(OUT,790)
      IFL=OPT(24)  
      IF(OPT(24).GT.5) OPT(24)=OPT(24)-5
      DO 150 I=1,20
      FMT(I)=VFMT(I,4) 
  150 IF(OPT(24).GT.2) FMT(I)=VFMT(I,5)
      IF(IFL.LT.5) GO TO 160
      READ (IN,590) FMT
      WRITE (OUT,780) (FMT(I),I=1,10)  
  160 IF(OPT(24).GT.2) GO TO 190
      DO 180 I=1,NR
      READ (IN,FMT) (B(J),J=1,NC)  
      DO 180 J=1,NC
      IF (FLAG(I,J)) 170,170,180
  170 DL(I,J)=(B(J)-H(I,J))/DELMAJ 
      IF(OPT(24).EQ.2)DL(I,J)=B(J)/DELMAJ  
  180 CONTINUE 
      GO TO 210
  190 READ (IN,FMT) II,III,JJ,JJJ,HA
      IF (II.LT.1) GO TO 210
      DO 200 I=II,III  
      DO 200 J=JJ,JJJ  
      HB=HA-H(I,J) 
      IF(OPT(24).EQ.4)HB=HA
  200 DL(I,J)=HB/DELMAJ
      GO TO 190
  210 CONTINUE 
C***********************************************************************
C      READ LIMITS OF STATISTICAL GRID BLOCKS  
C***********************************************************************
      IF (OPT(27).LT.1) GO TO 240  
      DO 220 I=1,20
  220 FMT(I)=VFMT(I,5) 
      IF(OPT(27).LT.5) GO TO 230
      READ (IN,650) FMT
      WRITE (OUT,780) (FMT(I),I=1,10)  
  230 NBLK=NBLK+1  
      READ (IN,FMT) (IRWC(J,NBLK),J=1,4)
      IF (IRWC(1,NBLK).GT.0) GO TO 230 
      NBLK=NBLK-1  
  240 CONTINUE 
C***********************************************************************
C     SAVE HEADS AT BEGINNING OF TIME STEP 
C***********************************************************************
      REWIND IN4
      WRITE (IN4) H
C***********************************************************************
C     BEGIN MINOR TIME STEP LOOP
C***********************************************************************
      DO 470 MINOR=1,NSP1  
      TIME=TIME+DELTA  
C***********************************************************************
C      CALCULATE TRANSMISSIVITIES  
C***********************************************************************
      DO 260 I=1,NR
      DO 260 J=1,NC
      T1=THIK(I,J) 
      IF(FLAG(I,J).EQ.1) T1=H(I,J)-BOTLEL(I,J) 
      T(I,J,1)=0.0 
      IF(J.EQ.NC) GO TO 250
      T2=THIK(I,J+1)
      IF(FLAG(I,J+1).EQ.1) T2=H(I,J+1)-BOTLEL(I,J+1)
      T2=2.*(T2*DELX(J)+T1*DELX(J+1))/(DELX(J)+DELX(J+1))**2
      T(I,J,1)=T2*P(I,J,1)*DELY(I) 
  250 T(I,J,2)=0.0 
      IF(I.EQ.NR) GO TO 260
      T2=THIK(I+1,J)
      IF(FLAG(I+1,J).EQ.1) T2=H(I+1,J)-BOTLEL(I+1,J)
      T2=2.*(T2*DELY(I)+T1*DELY(I+1))/(DELY(I)+DELY(I+1))**2
      T(I,J,2)=T2*P(I,J,2)*DELX(J) 
  260 CONTINUE 
  270 CONTINUE 
C***********************************************************************
C      WRITE HEADS FOR BEGINNING OF TIME STEP  
C***********************************************************************
      IF(MINOR.EQ.1.AND.KQUAL.GT.0) CALL SUMFLO(H,HO,T,R,RD,B,DELTA,
     1DELMAJ,NC,NR,NROW,NCOL,1,IN5,IN6)
C***********************************************************************
C     PREDICT HEAD FOR NEXT TIME STEP  
C***********************************************************************
      DO 310 J=1,NC
      DO 310 I=1,NR
      D=H(I,J)-HO(I,J) 
      HO(I,J)=H(I,J)
      IF(KSSH.GT.0) GO TO 310  
      IF (FLAG(I,J)) 280,280,290
  280 H(I,J)=H(I,J)+DELTA*DL(I,J)  
      IF(H(I,J).LT.BOTLEL(I,J))H(I,J)=BOTLEL(I,J)+0.1  
      GO TO 310
  290 CONTINUE 
      IF (FLAG(I,J).GT.2) GO TO 310
      F=0.0
      IF (ABS(DL(I,J)).LT.1.E-4) GO TO 300 
      IF(MINOR.GT.2)F=D/DL(I,J)
      IF(F.GT.5.0)F=5.0
      IF(F.LT.0.0)F=0.0
  300 DL(I,J)=D
      H(I,J)=H(I,J)+D*F
  310 CONTINUE 
C***********************************************************************
C     REFINE ESTIMATES OF HEADS BY IADI METHOD 
C  
C      CALL SUBROUTINE SOLVE TO PERFORM THE IADI PROCEDURE 
C***********************************************************************
      CALL SOLVE(NROW,NCOL,FLAG,H,HO,T,SF1,Q,R,RD,TOPAQ)
  320 CONTINUE 
      TIM=TIME/DELMJ2  
  330 CONTINUE 
      WRITE (OUT,560) TIME,TIM,E,ITER  
      DO 450 J=1,NC
      DO 450 I=1,NR
      SUMCHD=0.
      IFL=FLAG(I,J)+1  
      GO TO (340,350,350,450), IFL 
C***********************************************************************
C     DETERMINE FLOWS WITH CONSTANT HEAD CELLS 
C***********************************************************************
  340 IF(I.GT.1)SUMCHD=SUMCHD-T(I-1,J,2)*(H(I-1,J)-H(I,J))*DELTA
      IF(I.LT.NR)SUMCHD=SUMCHD+T(I,J,2)*(H(I,J)-H(I+1,J))*DELTA
      IF(J.GT.1)SUMCHD=SUMCHD-T(I,J-1,1)*(H(I,J-1)-H(I,J))*DELTA
      IF(J.LT.NC)SUMCHD=SUMCHD+T(I,J,1)*(H(I,J)-H(I,J+1))*DELTA
      IF(SUMCHD.GT.0.)SUMS(6,1)=SUMS(6,1)+SUMCHD
      IF(SUMCHD.LT.0.)SUMS(5,1)=SUMS(5,1)-SUMCHD
      GO TO 450
  350 CONTINUE 
      IF(KSSH.GT.0) HO(I,J)=H(I,J) 
       GO TO (450,351,352,450),IFL 
  351  HC=AMIN1(H(I,J),TOPAQ(I,J)) 
       HA=SF1(I,J)*(HC-HO(I,J))
       HB=SF1(I,J )/STRFCT*(H(I,J)-HC) 
       GO TO 353
  352  HC=AMAX1(H(I,J),TOPAQ(I,J)) 
       HA=SF1(I,J)*STRFCT*(H(I,J)-HC)  
       HB=SF1(I,J) *(HC-HO(I,J))
  353  IF(HA.GT.0.) SUMS(7,1)=SUMS(7,1)+ HA
       IF(HB.GT.0.) SUMS(17,1)=SUMS(17,1) + HB 
       IF(HA.LT.0.) SUMS(8,1)=SUMS(8,1) - HA
       IF(HB.LT.0.) SUMS(18,1) = SUMS(18,1) - HB
      HA=R(I,J)*(H(I,J)-RD(I,J))*DELTA 
      IF(R(I,J)) 360,380,370
  360 QSUM(I,J)=QSUM(I,J)-HA
      GO TO 380
  370 IF(H(I,J).LT.RD(I,J)) GO TO 380  
      QSUM(I,J)=QSUM(I,J)+HA
  380 CONTINUE 
C***********************************************************************
C      CHECK FOR CHANGE OF NODE TYPE
C***********************************************************************
      ITYPE=FLAG(I,J)+1
      GO TO (420,390,410,430),ITYPE
  390 IF(H(I,J).LE.TOPAQ(I,J)) GO TO 430
      IF(H(I,J).LE.SURF(I,J)) GO TO 400
      HA=RHG(I,J)*PMPFCT
      RHG(I,J)=0.0 
      Q(I,J)=Q(I,J)+HA 
      SUMS(10,1)=SUMS(10,1)+HA*(DELMAJ-TIME+TIME1) 
      WRITE(OUT,770) I,J,HA,XLGTNM 
C***********************************************************************
C      NODE CHANGED FROM WATER TABLE TO ARTESIAN
C***********************************************************************
  400 SF1(I,J)=SF1(I,J)/STRFCT 
      WRITE (OUT,750) I,J,H(I,J)
      FLAG(I,J)=2  
      GO TO 430
  410 IF(H(I,J).GT.TOPAQ(I,J)) GO TO 430
C***********************************************************************
C      NODE CHANGED FROM ARTESIAN TO WATER TABLE
C***********************************************************************
      SF1(I,J)=SF1(I,J)*STRFCT 
      WRITE (OUT,760) I,J,H(I,J)
      FLAG(I,J)=1  
      GO TO 430
  420 IF(H(I,J).GT.TOPAQ(I,J)) GO TO  430  
      THIK(I,J)=H(I,J)-BOTLEL(I,J) 
  430 CONTINUE 
C***********************************************************************
C     IF H IS BELOW BOTTOM ELEVATION, REDUCE PUMPAGE, IF POSSIBLE. 
C***********************************************************************
      IF (H(I,J).GT.BOTLEL(I,J)) GO TO 450 
      HA=Q(I,J)+RHG(I,J)*PMPFCT
      Q(I,J)=-RHG(I,J)*PMPFCT  
      IF(HA.LT.1.)HA=0.
      SUMS(9,1)=SUMS(9,1)+HA*(DELMAJ-TIME+TIME1)
C***********************************************************************
C      SET MINIMUM THICKNESS TO 0.1
C***********************************************************************
      H(I,J)=BOTLEL(I,J)+0.1
      WRITE (OUT,700) I,J,HA,XLGTNM
  440 CONTINUE 
  450 CONTINUE 
C***********************************************************************
C      SUM FLOW FOR THIS TIME STEP 
C***********************************************************************
      IF(KQUAL.GT.0) CALL SUMFLO(H,HO,T,R,RD,B,DELTA,DELMAJ,NC,NR,NROW,
     1NCOL,2,IN5,IN6)  
C***********************************************************************
C     PRINT MAP OF FLOWS - MINOR TIME STEP 
C***********************************************************************
      IF (OPT(12).GT.0) CALL FLUX (NROW,NCOL,H,T)  
C***********************************************************************
C     INCREASE SIZE OF TIME STEP
C***********************************************************************
      DELTA=DELTA*TIMACL
      IF (OPT(13).LT.1) GO TO 470  
C***********************************************************************
C     WRITE WATER LEVELS AT END OF MINOR TIME STEP.
C***********************************************************************
      WRITE(OUT,710)TITMOD,TITLE
      WRITE (OUT,740) TIME 
c***********************************************************************
      DO 460 I=1,NR
  460 WRITE (OUT,580) I,(H(I,J),J=1,NC)
C***********************************************************************
C     END MINOR TIME STEP LOOP 
C***********************************************************************
  470 CONTINUE 
      TIME1=TIME
  480 CONTINUE 
C***********************************************************************
C      WRITE RESULTS
C***********************************************************************
      CALL OUTPUT(NROW,NCOL,FLAG,H,HO,P,BOTLEL,SF1,T,THIK,TOPAQ,
     1SURF ,QSUM,R)
C***********************************************************************
C      CALL QUAL TO PERFORM MASS TRANSPORT 
C***********************************************************************
      IF(KQUAL.GT.0) CALL QUAL(R,RD,DL,TOPAQ,SURF,THIK,BOTLEL,H,HO,
     1HDUM,SF1,Q,T,P,RHG,QSUM,FLAG,NROW,NCOL,NSP1,TIMACL)  
C***********************************************************************
C     END MAJOR TIME STEP LOOP.
C***********************************************************************
  490 CONTINUE 
C***********************************************************************
C     PRINT HYDROGRAPHS
C***********************************************************************
      IF (KHYD.GT.0) CALL HYDRO (NROW,NCOL,FLAG,H,HO,T)
  500 WRITE (OUT,730)  
      IF(KOUT1.GT.0) END FILE OUT1 
      STOP 
C***********************************************************************
C  
C  
C  
C  
  510 FORMAT (//T20,'ITERATION PARAMETERS'//(T25,5F10.5))  
  520 FORMAT (10I5)
  530 FORMAT (4F10.0,4A6)  
  540 FORMAT (20I1)
  550 FORMAT (T20,'TIME STEP OPTION',I5,' EQUALS',I5)  
  560 FORMAT (' TIME =',E20.8,' DAYS OR ',F7.2,' MAJOR TIME STEPS,','HE
     1AD CHANGE SUM = ',F8.2,' FEET, ITERATIONS =',I5) 
  570 FORMAT (1H1) 
  580 FORMAT (1H0,I4,5X,10F10.3/(10X,10F10.3)) 
  590 FORMAT (20A4)
  600 FORMAT (14H1ERROR MESSAGE,I5,/,15H0LAST CARD READ,/,5X,1H/,20A4,1H
     1/)
  610 FORMAT (1H0,T4,'NODE',T12,'ROW',T18,'COL',T24,'FLAG',T33,'SURFAC',
     1T45,'TOP',1X,'OF',T54,'BOTTOM',T65,'THIK-',T75,'INIT-',T85,'PERM',
     2T95,'PERM',T103,'STORAGE'/T4,'TYPE',T32,'ELEVATION',T44,'AQUIFER',
     3T53,'ELEVATION',T65,'NESS',T75,'HEAD',T85,'X-DIR',T95,'Y-DIR',T104
     4,'COEF'/1X,28(4H----))
  620 FORMAT (1X,2A4,I4,2I6,3X,5F10.2,2F10.0,E10.4)
  630 FORMAT (5H NODE,2I3,37H CHANGED TO OUTCROP FOR HEAD EQUAL TOF10.3)
  640 FORMAT (26I3)
  650 FORMAT (20A4)
  660 FORMAT (T20,'NUMBER OF MAJOR TIME STEPS',T65,I5,/T20,'NUMBER OF MI
     1NOR TIME STEPS',T65,I5/T20,'SIZE OF MAJOR TIME STEPS',T60,F10.3,5X
     2,'DAYS'/T20,'SIZE OF FIRST MINOR TIME STEP',T60,F10.3,5X,'DAYS'/T2
     30,'ERROR CRITERIA',T60,F10.2/T20,'NUMBER OF COLUMNS',T65,I5,/T20,'
     1NUMBER OF ROWS',T65,I5/T20,'NUMBER OF ITERATION PARAMETERS',T65,I5
     1/T20,'NUMBER OF SPRINGS/RIVER CELLS',T65,I5/T20,'STORAGE RATIO',T6
     10,F10.3  
     5/T20,'TIME ACCELERATION FACTOR',T60,F10.3/T20,'FLUX CONVERSION FAC
     6TOR',T50,E20.8/T20,'EXTERNAL FLUX UNITS',T64,A6/T20,'PERMEABILITY
     7CONVERSION UNITS',T60,F10.6/T20,'PLOTTED FLOWS FACTOR',T50,E20.8/T
     820,'PLOT FLOWS UNITS NAME',T58,2A6/T20,'LENGTH UNIT NAME',T64,A6/)
  670 FORMAT (30I1,I5,2F10.0,6A4)  
  680 FORMAT (1H0,50X,6A4) 
  690 FORMAT (T35,'NUMBER OF MINOR TIME STEPS',T80,I5/T35,'LENGTH OF MAJ
     1OR TIME STEP',T75,F10.2/T35,'TIME ACCELERATION FACTOR',T75,F10.3)
  700 FORMAT (T5,' NODE',2I3,' DEWATERED, PUMPAGE REDUCED',E20.8,A6,'**3
     1/DAY')
  710 FORMAT(1H1,T25,20A4//T25,20A4/)  
  720 FORMAT (1H0,50X,'SIMULATING TIME STEP',I5)
  730 FORMAT (1H0,'*** JOB TERMINATED ***')
  740 FORMAT (' SIMULATED HEADS AT END OF',F10.3,' DAYS')  
  750 FORMAT (T5,'NODE',2I3,' CHANGED TO ARTESIAN FOR HEAD =',F10.3)
  760 FORMAT (T5,'NODE',2I3,' CHANGED TO WATER TABLE FOR HEAD =',F10.3)
  770 FORMAT (T5,'NODE',2I3,' SURFACE FLOW, RECHARGE REDUCED',E20.8,A6 
     1,'**3/DAY')  
  780 FORMAT (T70,'FORMAT IS',T80,10A4/)
  790 FORMAT(T20,'READ CONSTANT HEADS'/)
      END 
      include 'sumflo.for'
      include 'qsolve.for'
      include 'xsect.for'
      include 'plots.for'
      include 'ploth.for'
      include 'solve.for'
      include 'calib.for'
      include 'qread.for'
      include 'hydro.for'
      include 'physdt.for'
      include 'flux.for'
      include 'getpmp.for'
      include 'qual.for'
      include 'output.for'
      include 'blkdat.for' 
