      SUBROUTINE PLOTS (NROW,NCOL,FLAG,HSIM,HOBS,N)
C***********************************************************************
C     THIS SUBROUTINE PRODUCES A SYMBOLIC MAP OF VARIOUS PARAMETERS.
C     MAXIMUM NUMBER OF COLUMNS IS 100.
C     N=1  SIMULATION ERROR MAP
C     N=2 HEAD CHANGE DURING THIS TIME STEP
C     N=3 HEAD CHANGE THROUGH THIS TIME STEP
C***********************************************************************
      COMMON /ITCOM/ NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE, 
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25) 
     2,IN1,IN2,IN3,IN4,IN5,IN6 
     1,NSTEPS,NBLK,IRWC(4,60),NSPRG,ISPRG(25),JSPRG(25),KSSR,KQUAL
      COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     1(100),G(100),SUMSS(18,2),
     2                              ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,  
     3DELMAJ,E,XLGTNM,FLXNAM(2),FLXFCT 
     1,DELMJ2,TIME,STRFCT,SCALE
     1,TITMOD(20),VFMT(20,7)
      INTEGER OPT,FLAG,OUT,OUT1
      DIMENSION IFREQ(26),SYMBOL(26),XRANGE(27),PLOT(100), 
     1PERCT(26),HSIM(NROW,NCOL),HOBS(NROW,NCOL),FLAG(NROW,NCOL)
     1,XINTGR(10)  
      DATA XINTGR/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/ 
C***********************************************************************
C     XINCRE EQUALS THE RANGE FOR EACH PRINTER SYMBOL  
C***********************************************************************
      DATA XINCRE,BLANK,IFIRST/10.0,4H    ,0/  
      DATA SYMBOL/1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL, 
     11HM,1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ/ 
      DIMENSION IDUM(10)
      DATA IDUM/1,2,3,4,5,6,7,8,9,0/
      DIMENSION XROW(3), XCOL(2)
      DATA XROW/1HR,1HO,1HW/,XCOL/4HCOLU,4HMN  /
      DIMENSION SUMS(10),IMAXS(4,3),HMAXS(2,3) 
      ENTRY QPLOTS(NROW,NCOL,FLAG,HSIM,HOBS,QTITLE,N)  
      DIMENSION QTITLE(20) 
      HA=0 
      HB=-1.E-6
      HC=1.E6  
      M=0  
      DO 10 I=1,NR 
      DO 10 J=1,NC 
      IF(FLAG(I,J).GT.2) GO TO 10  
      IF(N.EQ.1.AND. ABS(HOBS(I,J)).LT.1.E-3) GO TO 10 
      M=M+1
      HD=HSIM(I,J)-HOBS(I,J)
      HA=HA+HD 
      HB=AMAX1(HB,HD)  
      HC=AMIN1(HC,HD)  
   10 CONTINUE 
      HA=HA/M  
      ERR=HC
      HB=(HB-HC)/26
      HC=0.1
      IF(HB.GT.0.1) HC=1.  
      IF(HB.GT.1.) HC=5.
      IF(HB.GT.5.) HC=10.  
      IF(HB.GT.10.) HC=25. 
      IF(HB.GT.25.) HC=50. 
      IF(HB.GT.50.) HC=100.
      HA=IFIX(HA/HC)*HC
      HB=IFIX(ERR/HC)*HC
      XRANGE(1)=-1.E6  
      XRANGE(27)=1.E6  
      ERR=HA-HC*12 
      XRANGE(2)=AMAX1(ERR,HB)  
      DO 20 I=3,26 
   20 XRANGE(I)=XRANGE(2)+HC*(I-2) 
      ORIGX=0. 
      IF(SCALE.GT.0.) GO TO 40 
      DO 30 J=1,NC 
   30 G(J)=J
      JST=1
      J=NC+1
      GO TO 90 
   40 CONTINUE 
      B(1)=0
      DO 50 I=2,NR 
   50 B(I)=B(I-1)+(DELY(I)+DELY(I-1))/2.
      G(1)=0.  
      DO 60 J=2,NC 
   60 G(J)=G(J-1)+(DELX(J)+DELX(J-1))/2.
      JST=1
      IF(G(NC)/SCALE.GT.50.) GO TO 360 
      IF(B(NR)/SCALE.GT.50.) GO TO 360 
   70 DO 80 J=JST,NC
      IF((G(J)-ORIGX).GT.9.9*SCALE) GO TO 90
   80 CONTINUE 
      J=NC+1
   90 JEND=J-1 
      GSAVE=G(JEND)
      IF(JST.EQ.JEND.AND.JST.NE.NC) GO TO 360  
      WRITE(OUT,800)TITMOD,TITLE
      IF(N.GT.3) WRITE (OUT,810) QTITLE
      GO TO (100,110,120,130,140,150),N
  100 WRITE(OUT,690) ISTEP                                                *
      GO TO 160
  110 WRITE(OUT,700) ISTEP                                                *
      GO TO 160
  120 WRITE(OUT,710) ISTEP                                                *
      GO TO 160
  130 WRITE (OUT,720) ISTEP
      GO TO 160
  140 WRITE (OUT,730) ISTEP
      GO TO 160
  150 WRITE (OUT,740) ISTEP
  160 CONTINUE 
      WRITE (OUT,770)  
      IF(SCALE.LE.1.E-3) GO TO 180 
      DO 170 J=JST,JEND
      K=(G(J)+SCALE/20.-ORIGX)/(SCALE/10.)+1
  170 G(J)=K+0.5
  180 WRITE (OUT,830)  XCOL
      DO 210 L=1,2 
      DO 190 K=1,100
  190 PLOT(K)=BLANK
      DO 200 J=JST,JEND
      KG=G(J)  
      KL=J/10  
      PLOT(KG)=XINTGR(KL)  
      IF(KL.EQ.0) PLOT(KG)=BLANK
      IF(L.EQ.1) GO TO 200 
      KL=MOD(J,10) 
      IF(KL.EQ.0) KL=10
      PLOT(KG)=XINTGR(KL)  
  200 CONTINUE 
  210 WRITE (OUT,790) PLOT 
      WRITE (OUT,760)  
      WRITE (OUT,840)  
      YDIS=B(1)
      DO 320 I=1,NR
      DO 220 K=1,100
  220 PLOT(K)=BLANK
      DO 280 J=JST,JEND
      KG=G(J)  
      IFL=FLAG(I,J)+1  
      GO TO (230,240,240,280),IFL  
  230 PLOT(KG)=1H* 
      GO TO 280
  240 ERR=HSIM(I,J)-HOBS(I,J)  
      IF(N.EQ.1.AND. ABS(HOBS(I,J)).LT.1.E-3) GO TO 280
      DO 250 KK=2,26
      IF(ERR.LT.XRANGE(KK)) GO TO 260  
  250 CONTINUE 
      IERR=26  
      GO TO 270
  260 IERR=KK-1
  270 PLOT(KG)=SYMBOL(IERR)
  280 CONTINUE 
      IF(SCALE.LT.1.) GO TO 310
      KK=0 
      IF(I.EQ.1) GO TO 310 
      IF(I.EQ.NR) GO TO 290
      IF((B(I+1)-YDIS).LT.SCALE/12.)GOTO  320  
  290 KK=(B(I)-YDIS)/(SCALE/6.) +.5
      DO 300 KL=1,KK
      IF(KK.LT.1) GO TO 300
      WRITE (OUT,780)  
  300 CONTINUE 
  310 WRITE (OUT,670) I,PLOT
      YDIS=YDIS+SCALE/6.*(KK+1)
  320 CONTINUE 
      WRITE (OUT,760)  
      WRITE (OUT,830) XCOL 
      DO 350 L=1,2 
      DO 330 K=1,100
  330 PLOT(K)=BLANK
      DO 340 J=JST,JEND
      KG=G(J)  
      KL=J/10  
      PLOT(KG)=XINTGR(KL)  
      IF(KL.EQ.0) PLOT(KG)=BLANK
      IF(L.EQ.1) GO TO 340 
      KL=MOD(J,10) 
      IF(KL.EQ.0) KL=10
      PLOT(KG)=XINTGR(KL)  
  340 CONTINUE 
  350 WRITE (OUT,790) PLOT 
      JST=JEND 
      ORIGX=GSAVE  
      G(JST)=GSAVE 
      IF(JST.LT.NC) GO TO 70
      GO TO 370
  360 WRITE (OUT,850)  
  370 CONTINUE 
      DO 570 NBLKN=1,NBLK  
      HMAX=-1.E6
      HMIN=1.E6
      DO 380 K=1,10
  380 SUMS(K)=0.
      DO 390 K=1,3 
      HMAXS(1,K)=-1.E6 
  390 HMAXS(2,K)=1.E6  
      DO 400 I=1,26
  400 IFREQ(I)=0.  
      XNODE=0.0
      IST=IRWC(1,NBLKN)
      IEND=IRWC(2,NBLKN)
      JST=IRWC(3,NBLKN)
      JEND=IRWC(4,NBLKN)
      DO 520 I=IST,IEND
      DO 510 J=JST,JEND
      IFL=FLAG(I,J)+1  
      GO TO(510,410,410,510),IFL
  410 ERR=HSIM(I,J)-HOBS(I,J)  
      IF(N.EQ.1.AND. ABS(HOBS(I,J)).LT.1.E-3) GO TO 510
      XNODE=XNODE+1.
      DO 420 KK=2,26
      IF(ERR.LT.XRANGE(KK)) GO TO 430  
  420 CONTINUE 
      IERR=26  
      GO TO 440
  430 IERR=KK-1
  440 IFREQ(IERR)=IFREQ(IERR)+1
      DO 500 K=1,3 
      GO TO (450,460,470), K
  450 HA=HSIM(I,J) 
      GO TO 480
  460 HA=HOBS(I,J) 
      GO TO 480
  470 HA=ERR
  480 HDUM=HMAXS(1,K)  
      HMAX=AMAX1(HA,HMAXS(1,K))
      IF (HDUM.GE.HMAX) GO TO 490  
      HMAXS(1,K)=HMAX  
      IMAXS(1,K)=I 
      IMAXS(2,K)=J 
  490 HDUM=HMAXS(2,K)  
      HMIN=AMIN1(HA,HMAXS(2,K))
      IF (HDUM.LE.HMIN) GO TO 500  
      HMAXS(2,K)=HMIN  
      IMAXS(3,K)=I 
      IMAXS(4,K)=J 
  500 CONTINUE 
      SUMS(1)=SUMS(1)+1.
      SUMS(2)=SUMS(2)+HSIM(I,J)*HOBS(I,J)  
      SUMS(3)=SUMS(3)+HSIM(I,J)*HSIM(I,J)  
      SUMS(4)=SUMS(4)+HSIM(I,J)
      SUMS(5)=SUMS(5)+HOBS(I,J)*HOBS(I,J)  
      SUMS(6)=SUMS(6)+HOBS(I,J)
      SUMS(7)=SUMS(7)+ERR*ERR  
      SUMS(8)=SUMS(8)+ERR  
      ERR=ABS(ERR) 
      SUMS(9)=SUMS(9)+ERR*ERR  
      SUMS(10)=SUMS(10)+ERR
  510 CONTINUE 
  520 CONTINUE 
      IF (NBLKN.GT.1) GO TO 540
      PERCT(1)=FLOAT(IFREQ(1))/XNODE*100.  
      DO 530 I=2,26
  530 PERCT(I)=FLOAT(IFREQ(I))/XNODE*100.+PERCT(I-1)
      WRITE (OUT,750)  
      WRITE (OUT,760) (SYMBOL(I),XRANGE(I),XRANGE(I+1),IFREQ(I),PERCT(I)
     1,I=1,26) 
      WRITE (OUT,650)  
  540 WRITE (OUT,580) NBLKN,IST,IEND,JST,JEND  
      WRITE (OUT,600)  
      DO 550 K=4,10,2  
  550 SUMS(K)=SUMS(K)/SUMS(1)  
      WRITE (OUT,590) (SUMS(K),K=4,10,2)
      SS=SUMS(7)
      DO 560 K=3,9,2
  560 SUMS(K)=SQRT((SUMS(1)*SUMS(K)-(SUMS(1)*SUMS(K+1))**2)/(SUMS(1)*(SU
     1MS(1)-1.)))  
      WRITE (OUT,620) (SUMS(K),K=3,9,2)
      WRITE (OUT,630) (HMAXS(1,K),K=1,3),((IMAXS(L,K),K=1,3),L=1,2)
      WRITE (OUT,640) (HMAXS(2,K),K=1,3),((IMAXS(L,K),K=1,3),L=3,4)
      WRITE (OUT,610) SUMS(1)  
      COV=(SUMS(2)-SUMS(1)*SUMS(4)*SUMS(6))/(SUMS(1)-1.)
      REG=COV/(SUMS(3)*SUMS(5))
      WRITE (OUT,660) SS,COV,REG
  570 CONTINUE 
C***********************************************************************
      RETURN
C  
C  
C  
C  
  580 FORMAT (/T42,'FOR BLOCK',I3,' FROM ROW',I3,' TO',I3,' AND FROM','
     1COLUMN',I3,' TO',I3) 
  590 FORMAT (T5,'MEAN',T31,4F20.4)
  600 FORMAT (/T42,'SIMULATED',T63,'OBS/INIT',T81,'DIFFERENCE',T103,'ABS
     1 DIFF'/) 
  610 FORMAT (T5,'NUMBER OF CELLS',T31,F20.4)  
  620 FORMAT (T5,'STANDARD DEVIATION',T31,4F20.4)  
  630 FORMAT (T5,'MAXIMUM-VALUE',T31,3F20.4/T13,'ROW',T31,3I20/T13,'COLU
     1MN',T31,3I20)
  640 FORMAT (T5,'MINIMUM-VALUE',T31,3F20.4/T13,'ROW',T31,3I20/T13,'COLU
     1MN',T31,3I20)
  650 FORMAT (4X,'*',8X,'CONSTANT HEAD'/)  
  660 FORMAT (T5,'SUM OF SQUARED DIFFERENCES',T31,F20.4/T5,'COVARIANCE',
     1T31,F20.4/T5,'REGRESSION COEFFICIENT',T31,F20.4) 
  670 FORMAT (1H ,I5,4X,1H.,100A1) 
  680 FORMAT (22H0SUM OF ERRORS SQUARED,2X,F10.1)  
  690 FORMAT (39H0ERROR MAP FOR SIMULATION FOR TIME STEP,I4)
  700 FORMAT (28H0HEAD CHANGES FOR TIME STEP ,I4)  
  710 FORMAT ('0HEAD CHANGES FROM BEGINNING OF SIMULATION',' THROUGH TIM
     1E STEP',I4)  
  720 FORMAT ('0QUALITY ERROR MAP FOR TIME STEP',I4)
  730 FORMAT ('0QUALITY CHANGES DURING TIME STEP',I4)  
  740 FORMAT ('0QUALITY CHANGES FROM BEGINNING THRU TIME STEP',I4) 
  750 FORMAT (1H0,T25,'FREQUENCY DISTRIBUTION',//,' SYMBOL',12X,9HRANGE(
     1FT),12X,9HFREQUENCY,5X,'PER CENT .LE.'//)
  760 FORMAT (1H ,3X,A1,8X,F8.3,4H TO ,F8.3,9X,I4,6X,F10.1)
  770 FORMAT (1H0,19X,100I1)
  780 FORMAT (10X,1H.,100I1)
  790 FORMAT (11X,100A1)
  800 FORMAT(1H1,T25,20A4//T25,20A4/)  
  810 FORMAT (25X,20A4/)
  820 FORMAT (1H+,A1)  
  830 FORMAT (10X,2A4) 
  840 FORMAT (T5,'ROW')
  850 FORMAT (' SCALE INCORRECT   PLOT TERMINATED'//)  
      END  
