       SUBROUTINE QSOLVE(H,HO,T,SF1,R,Q1,Q2,Q,BOTLEL,RD,Q3,RHG,THIK,
     1B,G,FLAG,ERROR,DELMAJ,NROW,NCOL,NR,NC,ITER,ALPHA)
      DIMENSION Q1(NROW,NCOL),Q2(NROW,NCOL),THIK(NROW,NCOL),
     1RD(NROW,NCOL),RHG(NROW,NCOL),
     2 BOTLEL(NROW,NCOL),Q3(NROW,NCOL) 
C***********************************************************************
C     THIS ROUTINE SOLVES FOR CONCENTRATIONS BY THE IDAI PROCEDURE 
C***********************************************************************
      DIMENSION H(NROW,NCOL),HO(NROW,NCOL),T(NROW,NCOL,2), 
     1 B(1),G(1),SF1(NROW,NCOL),Q(NROW,NCOL),R(NROW,NCOL)  
C***********************************************************************
C      ALPHA IS A CALIBRATION VALUE WHICH WEIGHTS THE CONCENTRATION
C       OF THE FLUX BETWEEN CELL.  RANGE OF VALUES IS FROM 0.5 TO 1.0  
C       A VALUE OF ONE MEANS NO AVERAGING OF CONCENTRATIONS
C       C(I->J)=ALPHA*C(I)+(1-ALPHA)*C(J)  
C***********************************************************************
           DOUBLE PRECISION AA,BB,CC,DD,W  
      INTEGER FLAG(NROW,NCOL)  
      ISTEP=1  
      ITER=0
10    CONTINUE 
      ITER=ITER+1  
      IF (ITER.GT.50) GO TO 810
      E=0.0
C***********************************************************************
C     ROW CALCULATIONS 
C***********************************************************************
      DO 410 II=1,NR
      I=II 
      IF(MOD(ISTEP+ITER,2).EQ.1)I=NR-I+1
      JSTRT=1  
20    DO 30 JJ=JSTRT,NC
      IFL=FLAG(I,JJ)+1 
      GO TO (30,40,40,30), IFL 
30    CONTINUE 
      GO TO 410
40    CONTINUE 
      JJP1=JJ+1
50    DO 60 JJJ=JJP1,NC
      IFL=FLAG(I,JJJ)+1
      GO TO (70,60,60,70), IFL 
60    CONTINUE 
      JJJ=NC
      JSTRT=NC 
      GO TO 80 
70    JJJ=JJJ-1
      JSTRT=JJJ+1  
80    CONTINUE 
      DO 370 J=JJ,JJJ  
      BB=R(I,J)/DELMAJ 
      DD=RD(I,J)/DELMAJ*HO(I,J)
90    CONTINUE 
      BB=BB+Q3(I,J)
      DD=DD+RHG(I,J)*Q(I,J)
      AA=0.0
      CC=0.0
      IF (J-JJ) 100,100,110
100   IF (J-1) 170,170,110 
110   TT=T(I,J-1,1)
      HA=Q1(I,J-1) 
      AA=-TT
      BB=BB+TT 
      HB=HO(I,J-1) 
      IF (HA) 120,170,130  
120   FACT=ALPHA
      FACT1=1.-FACT
      GO TO 140
130   FACT1=ALPHA  
      FACT=1.-FACT1
140   BB=BB-HA*FACT
      IF (FLAG(I,J-1)) 160,160,150 
150   AA=AA-HA*FACT1
      GO TO 170
160   DD=DD+H(I,J-1)*(HA*FACT1+TT) 
      AA=0.
170   IF (J-JJJ) 190,180,190
180   IF (J-NC) 190,260,260
190   TT=T(I,J,1)  
      HA=Q1(I,J)
      CC=-TT
      BB=BB+TT 
      HB=HO(I,J+1) 
      IF (HA) 200,260,210  
200   FACT1=ALPHA  
      FACT=1.-ALPHA
      GO TO 220
210   FACT=ALPHA
      FACT1=1.-ALPHA
220   BB=BB+HA*FACT
230   IF (FLAG(I,J+1)) 250,250,240 
240   CC=CC+HA*FACT1
      GO TO 260
250   DD=DD+H(I,J+1)*(TT-HA*FACT1) 
      CC=0.
260   IF (I-1) 270,310,270 
270   TT=T(I-1,J,2)
      HA=Q2(I-1,J) 
      BB=BB+TT 
      DD=DD+TT*H(I-1,J)
      HB=HO(I-1,J) 
      IF (HA) 280,310,290  
280   FACT=ALPHA
      FACT1=1.-FACT
      GO TO 300
290   FACT1=ALPHA  
      FACT=1.-FACT1
300   BB=BB-HA*FACT
      DD=DD+HA*FACT1*H(I-1,J)  
310   IF (I-NR) 320,360,320
320   TT=T(I,J,2)  
      HA=Q2(I,J)
      BB=BB+TT 
      DD=DD+TT*H(I+1,J)
      HB=HO(I+1,J) 
      IF (HA) 330,360,340  
330   FACT1=ALPHA  
      FACT=1.-FACT1
      GO TO 350
340   FACT=ALPHA
      FACT1=1.-FACT
350   BB=BB+HA*FACT
      DD=DD-HA*FACT1*H(I+1,J)  
360   W=BB-AA*B(J-1)
      B(J)=CC/W
370   G(J)=(DD-AA*G(J-1))/W
C***********************************************************************
C     RE-ESTIMATE CONCENTRATIONS
C***********************************************************************
      E=E+ABS(H(I,JJJ)-G(JJJ)) 
      H(I,JJJ)=G(JJJ)  
      N=JJJ
380   N=N-1
      IF (N-JJ+1) 400,400,390  
390   HA=G(N)-B(N)*H(I,N+1)
      E=E+ABS(HA-H(I,N))
      H(I,N)=HA
      GO TO 380
400   IF (JSTRT-NC) 20,410,410 
410   CONTINUE 
C***********************************************************************
C     COLUMN CALCULATIONS  
C***********************************************************************
      DO 800 JJ=1,NC
      J=JJ 
      IF(MOD(ISTEP+ITER,2).EQ.1)J=NC-J+1
      ISTRT=1  
420   DO 430 II=ISTRT,NR
      IFL=FLAG(II,J)+1 
      GO TO (430,440,440,430), IFL 
430   CONTINUE 
      GO TO 800
440   CONTINUE 
      IIP1=II+1
450   DO 460 III=IIP1,NR
      IFL=FLAG(III,J)+1
      GO TO (470,460,460,470), IFL 
460   CONTINUE 
      III=NR
      ISTRT=NR 
      GO TO 480
470   III=III-1
      ISTRT=III+1  
480   CONTINUE 
      DO 760 I=II,III  
      BB=R(I,J)/DELMAJ 
      DD=RD(I,J)/DELMAJ*HO(I,J)
      DD=DD+RHG(I,J)*Q(I,J)
      BB=BB+Q3(I,J)
      AA=0.0
      CC=0.0
      IF (J-1) 490,530,490 
490   TT=T(I,J-1,1)
      HA=Q1(I,J-1) 
      BB=BB+TT 
      DD=DD+TT*H(I,J-1)
      HB=HO(I,J-1) 
      IF (HA) 500,530,510  
500   FACT=ALPHA
      FACT1=1.-FACT
      GO TO 520
510   FACT1=ALPHA  
      FACT=1.-FACT1
520   BB=BB-HA*FACT
      DD=DD+HA*FACT1*H(I,J-1)  
530   IF (J-NC) 540,580,540
540   TT=T(I,J,1)  
      HA=Q1(I,J)
      BB=BB+TT 
      DD=DD+TT*H(I,J+1)
      HB=HO(I,J+1) 
      IF (HA) 550,580,560  
550   FACT1=ALPHA  
      FACT=1.-FACT1
      GO TO 570
560   FACT=ALPHA
      FACT1=1.-FACT
570   BB=BB+HA*FACT
      DD=DD-HA*FACT1*H(I,J+1)  
580   IF (I-II) 590,590,600
590   IF (I-1) 660,660,600 
600   TT=T(I-1,J,2)
      HA=Q2(I-1,J) 
      BB=BB+TT 
      AA=-TT
      HB=HO(I-1,J) 
      IF (HA) 610,660,620  
610   FACT=ALPHA
      FACT1=1.-FACT
      GO TO 630
620   FACT1=ALPHA  
      FACT=1.-FACT1
630   BB=BB-HA*FACT
      IF (FLAG(I-1,J)) 650,650,640 
640   AA=AA-HA*FACT1
      GO TO 660
650   DD=DD+H(I-1,J)*(HA*FACT1+TT) 
      AA=0.
660   IF (I-III) 680,670,680
670   IF (I-NR) 680,750,750
680   TT=T(I,J,2)  
      HA=Q2(I,J)
      BB=BB+TT 
      CC=-TT
      HB=HO(I+1,J) 
      IF (HA) 690,750,700  
690   FACT1=ALPHA  
      FACT=1.-ALPHA
      GO TO 710
700   FACT=ALPHA
      FACT1=1.-FACT
710   BB=BB+HA*FACT
720   IF (FLAG(I+1,J)) 740,740,730 
730   CC=CC+HA*FACT1
      GO TO 750
740   DD=DD+H(I+1,J)*(TT-HA*FACT1) 
      CC=0.
750   W=BB-AA*B(I-1)
      B(I)=CC/W
760   G(I)=(DD-AA*G(I-1))/W
C***********************************************************************
C     RE-ESTIMATE CONCENTRATIONS
C***********************************************************************
      E=E+ABS(H(III,J)-G(III)) 
      H(III,J)=G(III)  
      N=III
770   N=N-1
      IF (N-II+1) 790,790,780  
780   HA=G(N)-B(N)*H(N+1,J)
      E=E+ABS(H(N,J)-HA)
      H(N,J)=HA
      GO TO 770
790   IF (ISTRT-NR) 420,800,800
800   CONTINUE 
      IF (E.GT.ERROR) GO TO 10 
810   RETURN
C***********************************************************************
      END  
