      SUBROUTINE QUAL(R,RD,DL,TOPAQ,SURFAC,THIK,BOTLEL,H,HO,HBEGN,SF1, 
     1Q,T,P,RHG,QSUM,FLAG,NROW,NCOL,NSTEP,TIMACL)  
      COMMON /ITCOM/NR,NC,ISTEP,NPARM,IN,OUT,OUT1,OPT(30),ITER,NSAVE,  
     1ISAVE(25),JSAVE(25),KHYD,NCOLS,MCOLS(25),NROWS,MROWS(25),IN1,
     2IN2,IN3,IN4,IN6,IN7,NSTEPS,NBLK,IRWC(4,60),NSPRNG,ISPRNG( 25),
     3JSPRNG(25),KSSH,KQUAL
      COMMON /RLCOM/ FMT(20),TITLE(20),DELX(100),DELY(100),PRMITR(10),B
     3(100),G(100),SUMS(18,2),ERROR,PMPFCT,PMPNAM,PERFCT,DELTA,DELMAJ, 
     2E,XLGTNM,FLXNAM(2),FLXFCT,DELMJ2,TIME,STRFCT,SCALE,  
     4TITMOD(20),VFMT(20,7)
C********************************************************************  
C     THIS SUBROUTINE PERFORMS THE MASS TRANSPORT SIMULATION
C********************************************************************  
      DIMENSION R(NROW,NCOL), RD(NROW,NCOL), THIK(NROW,NCOL), BOTLEL(NRO
     1W,NCOL), H(NROW,NCOL), HO(NROW,NCOL), SF1(NROW,NCOL), Q(NROW,NCOL)
     1,T(NROW,NCOL,2),P(NROW,NCOL,2),SURFAC(NROW,NCOL),RHG(NROW,NCOL)  
     2,QSUM(NROW,NCOL),IOPT(30),TOPAQ(NROW,NCOL),QTITLE(20),HBEGN(NROW,N
     2COL) ,DL(NROW,NCOL)  
     7,IDCF(4) 
      INTEGER FLAG(NROW,NCOL),OUT  
      IN8=IN
      IN9=19
      DATA KOT/0/  
C********************************************************************  
C     EQUIVALENT NAMES 
C     R = CONCENTRATION AT TIME T  
C     RD= CONCENTRATION AT TIME T+1
C      P = DISPERSIVITY COEFFICIENTS
C     T = COLLECTED TERMS  
C     HBEGN = INITIAL CONCENTRATIONS AT T=0
C     TOPAQ  = FLOWS IN X-DIRECTION
C     DL     = FLOWS IN Y-DIRECTION
C     SURFAC = RECHARGE QUALITY CONCENTRATION  
C     QERROR = MINIMUM QUALITY CHANGE ALLOWED FOR CONVERGENCE  
C    SF1     = POROSITY
C     NSTEP  = NUMBER OF SMALL TIME STEP (MUST EQUAL NSP OF MAIN)  
C     IOPT   = OPTIONS 
C          1 = READ DISPERSIVITY COEFFICIENTS FOR EACH CELL
C          2 = WRITE DISPERSIVITY COEFFICIENTS FOR EACH CELL
C          3 = READ DISPERSIVITY COEFFICIENTS BY BLOCK 
C          4 = READ DISPERSIVITY COEFFICIENT ADJUSTMENTS
C          5 = READ RECHARGE QUALITIES FOR EACH CELL
C          6 = WRITE RECHARGE QUALITIES FOR EACH CELL  
C          7 = READ RECHARGE QUALITY BY BLOCK  
C          8 = READ RECHARGE QUALITY ADJUSTMENTS
C          9 = LIST CONCENTRATIONS AT END OF STEP  
C         10 = PLOT CONCENTRATIONS AT END OF STEP  
C         11 = LIST CHANGES IN CONCENTRATIONS DURING THIS STEP 
C         12 = PLOT CONCENTRATION CHANGES DURING THIS STEP 
C         13 = PLOT CONCENTRATION CHANGES THROUGH THIS STEP
C         14 = READ MEASURED VALUES OF CONCENTRATIONS AND PLOT 
C              ERROR MAP
C         15 = READ IN INITIAL CONCENTRATIONS FOR EACH CELL
C         16 = WRITE INITIAL CONCENTRATIONS FOR EACH CELL  
C         17 = READ INITIAL CONCENTRATIONS BY BLOCK
C         18 = READ INITIAL CONCENTRATIONS ADJUSTMENTS 
C         19 = LIST CONCENTRATION AT END OF SMALL TIME STEP
C         20 = LIST CHANGES IN CONCENTRATIONS THROUGH THIS STEP
C         21 = READ POROSITY FOR EACH CELL 
C         22 = WRITE POROSITY FOR EACH CELL
C         23 = READ POROSITY BY BLOCK  
C         24 = READ POROSITY ADJUSTMENTS
C********************************************************************  
      IF (KOT.GT.0) GO TO 10
      SUMD=0.0 
      SUMI=0.0 
      SUMO=0.0 
      SUME=0.0 
C********************************************************************  
C     READ TITLE, OPTIONS, CONVERGENCE CRITERION, AND STORAGE FACTOR
C********************************************************************  
      READ (IN8,1160) QTITLE
      READ(IN8,1110) IOPT,  QERROR,HA  
      ALPHA=1. 
      IF(HA.GT.1.E-5) ALPHA=HA 
      GO TO 20 
   10 READ (IN8,1110) IOPT 
   20 CONTINUE 
      WRITE (OUT,1120) TITLE,QTITLE
      WRITE(OUT,1140)ISTEP,QERROR,ALPHA
      DELTA=1. 
      N=NSTEP  
   30 N=N-1
      IF (N) 50,50,40  
   40 DELTA=DELTA+TIMACL**N
      GO TO 30 
   50 DELTA=DELMAJ/DELTA
      WRITE (OUT,1100) NSTEP,DELTA 
      DEL=DELTA
      DO 60 I=1,30 
   60 IF (IOPT(I).GT.0) WRITE (OUT,1150) I 
C********************************************************************  
C     SAVE HYDRAULIC SIMULATION COEFFICIENTS ON 'IN7'  
C********************************************************************  
      REWIND IN7
      WRITE(IN7) R,RD,P,T,SURFAC,HBEGN,DL,TOPAQ,SF1
      WRITE (IN7) H,HO 
      IF (KOT.LT.1) GO TO 70
C********************************************************************  
C     FOR SECOND OR LATER TIME STEP, READ MASS TRANSPORT
C     COEFFICIENTS FROM 'IN9'  
C********************************************************************  
      REWIND IN9
      READ (IN9) ((R(I,J),RD(I,J),P(I,J,1),P(I,J,2),SURFAC(I,J),HBEGN(I,
     1J),SF1(I,J),I=1,NR),J=1,NC)  
      READ (IN9) H,HO  
   70 CONTINUE 
      I=IOPT(1)+IOPT(3)+IOPT(4)
      IF(I.LT.1) GO TO 110 
C**********************************************************************
C    READ DISPERSIVITY COEFFICIENTS
C**********************************************************************
      DO 104 I=1,4 
  104 IDCF(I)=0
      IF(IOPT(1).LT.1) GO TO 105
      IDCF(1)=IOPT(1)  
      IDCF(2)=IOPT(2)  
      CALL QREAD(QTITLE,P(1,1,1),IDCF,NROW,NCOL,1) 
      CALL QREAD(QTITLE,P(1,1,2),IDCF,NROW,NCOL,5) 
      IDCF(1)=0
  105 IF(IOPT(3).LT.1) GO TO 107
      IDCF(3)=IOPT(3)  
      CALL QREAD(QTITLE,P(1,1,1),IDCF,NROW,NCOL,1) 
      CALL QREAD(QTITLE,P(1,1,2),IDCF,NROW,NCOL,5) 
      IDCF(3)=0
  107 IF(IOPT(4).LT.1) GO TO 110
      IDCF(4)=IOPT(4)  
      CALL QREAD(QTITLE,P(1,1,1),IDCF,NROW,NCOL,1) 
      CALL QREAD(QTITLE,P(1,1,2),IDCF,NROW,NCOL,5) 
  110 I=IOPT(5)+IOPT(7)+IOPT(8)
      IF(I.LT.1) GO TO 120 
C**********************************************************************
C    READ RECHARGE QUALITIES
C**********************************************************************
      CALL QREAD(QTITLE,SURFAC,IOPT(5),NROW,NCOL,2)
  120 I=IOPT(15)+IOPT(17)+IOPT(18) 
      IF(I.LT.1) GO TO 130 
C**********************************************************************
C    READ INITIAL CONCENTRATIONS
C**********************************************************************
      CALL QREAD(QTITLE,R,IOPT(15),NROW,NCOL,3)
  130 I=IOPT(21)+IOPT(23)+IOPT(24) 
      IF(I.LT.1) GO TO 140 
C**********************************************************************
C    READ POROSITY 
C**********************************************************************
      CALL QREAD(QTITLE,SF1,IOPT(21),NROW,NCOL,4)  
  140 CONTINUE 
      KOT=KOT+1
      IF (KOT.GT.1) GO TO 90
C********************************************************************  
C     CALCULATE INITIAL VOLUME IN STORAGE  
C********************************************************************  
      REWIND IN4
      READ(IN4) HO 
      DO 80 J=1,NC 
      DO 80 I=1,NR 
      HO(I,J)=THIK(I,J)
      IF(FLAG(I,J).EQ.1)HO(I,J)=(HO(I,J)-BOTLEL(I,J))  
      HO(I,J)=HO(I,J)*SF1(I,J)*DELX(J)*DELY(I) 
   80 CONTINUE 
   90 CONTINUE 
      IF (ISTEP.GT.1) GO TO 550
      DO 540 J=1,NC
      DO 540 I=1,NR
  540 HBEGN(I,J)=R(I,J)
  550 CONTINUE 
C********************************************************************  
C     ADD FLOWS FROM AQUIFER TO PUMPAGE
C********************************************************************  
      DO 560 J=1,NC
      DO 560 I=1,NR
      IF(QSUM(I,J).GT.0.) Q(I,J)=Q(I,J)+QSUM(I,J)/DELMAJ
  560 CONTINUE 
C********************************************************************  
C      REWIND STORAGE DEVICE
C********************************************************************  
      CALL SUMFLO (TOPAQ,DL,T,R,RD,B,DELTA,DELMAJ,NC,NR,NROW,NCOL,5,IN6,
     1IN7) 
      DO 600 I=1,NR
      DO 600 J=1,NC
      RD(I,J)=R(I,J)
      IF(FLAG(I,J).EQ.1) THIK(I,J)=H(I,J)-BOTLEL(I,J)  
C********************************************************************  
C      CONVERT Q FROM NET WITHDRAWAL TO ASSIGNED PUMPAGE
C      PLUS SPRING FLOWS
C     PLUS FLOWS FROM AQUIFER  
C********************************************************************  
      Q(I,J)=Q(I,J)+RHG(I,J)*PMPFCT
C********************************************************************  
C     RHG EQUALS RECHARGE PLUS FLOWS TO AQUIFER
C********************************************************************  
      RHG(I,J)=RHG(I,J)*PMPFCT 
      IF(QSUM(I,J).LT.1.) RHG(I,J)=RHG(I,J)-QSUM(I,J)/DELMAJ
  600 CONTINUE 
      DELTA=DEL
C********************************************************************  
C     SAVE CONCENTRATIONS AT BEGINNING OF TIME STEP
C********************************************************************  
      REWIND IN9
      WRITE (IN9) R
C********************************************************************  
C      BEGIN SMALL TIME STEPS  
C********************************************************************  
      DO 920 NSMAL=1,NSTEP 
      SUMST=0.0
      SUMEN=0.0
      SUMP=0.0 
      SUMR=0.0 
C********************************************************************  
C     READ GROUNDWATER FLOW
C********************************************************************  
      CALL SUMFLO (TOPAQ,DL,T,R,RD,B,DELTA,DELMAJ,NC,NR,NROW,NCOL,3,IN6,
     1IN7) 
C**********************************************************************
C    CALCULATE DISPERSION TERMS
C**********************************************************************
      DO 590 I=1,NR
      DO 590 J=1,NC
      IF(FLAG(I,J).LT.3) GO TO 570 
      T(I,J,1)=0.0 
      T(I,J,2)=0.0 
      GO TO 590
  570 HA=TOPAQ(I,J)/(THIK(I,J)*DELY(I)*SF1(I,J))
      HB=DL(I,J)/(THIK(I,J)*DELX(J)*SF1(I,J))  
      HC=SQRT(HA*HA+HB*HB+1.E-5)
      IF(J.EQ.NC) GO TO 575
      IF(FLAG(I,J+1).LT.3) GO TO 571
      T(I,J,1)=0
      GO TO 575
  571 T(I,J,1)=(P(I,J,1)*HA*HA+P(I,J,2)*HB*HB)/HC*(THIK(I,J)+  
     1THIK(I,J+1))*DELY(I)/(DELX(J)+DELX(J+1)) 
  575 IF(I.EQ.NR) GO TO 590
      IF(FLAG(I+1,J).LT.3) GO TO 576
      T(I,J,2)=0.  
      GO TO 590
  576 T(I,J,2)=(P(I,J,2)*HA*HA+P(I,J,1)*HB*HB)/HC*(THIK(I,J)+  
     1THIK(I+1,J))*DELX(J)/(DELY(I)+DELY(I+1)) 
  590 CONTINUE 
C********************************************************************  
C     CALCULATE VOLUME AT END OF STEP  
C********************************************************************  
      DO 690 I=1,NR
      DO 690 J=1,NC
      HA=0.0
      IF (FLAG(I,J).GT.2) GO TO 690
      H(I,J)=HO(I,J)
      IF (FLAG(I,J).LT.1) GO TO 690
      IF (J-1) 620,620,610 
  610 HA=HA+TOPAQ(I,J-1)
  620 IF (J-NC) 630,640,640
  630 HA=HA-TOPAQ(I,J) 
  640 IF (I-1) 660,660,650 
  650 HA=HA+DL(I-1,J)  
  660 IF (I-NR) 670,680,680
  670 HA=HA-DL(I,J)
  680 HA=HA-Q(I,J)+RHG(I,J)
      H(I,J)=HA*DELTA+HO(I,J)  
  690 CONTINUE 
C********************************************************************  
C     CALL QSOLVE TO PERFORM IADI PROCEDURE
C********************************************************************  
      CALL QSOLVE(RD,R,T,SF1,H,TOPAQ,DL,SURFAC,BOTLEL,HO,Q,RHG,THIK,
     1B,G,FLAG,QERROR,DELTA,NROW,NCOL,NR,NC,ITER,ALPHA)
C********************************************************************  
C     CALCULATE MASS BALANCE VALUES
C********************************************************************  
      ALPHA1=1.0-ALPHA 
      DO 870 I=1,NR
      DO 870 J=1,NC
      IF(RD(I,J).LT.0.0)   RD(I,J)=0.0 
      IF (FLAG(I,J).GT.2) GO TO 870
      HA=0.
      HB=0.0
      IF(FLAG(I,J).NE.0) GO TO 860 
      IF(I-1) 730,730,700  
  700 IF(FLAG(I-1,J).EQ.0) GO TO 730
      HC=T(I-1,J,2)*(RD(I-1,J)-RD(I,J))
      IF(HC.GT.0.)HA=HA+HC 
      IF(HC.LT.0.) HB=HB-HC
      IF(DL(I-1,J))710,730,720 
  710 HB=HB- DL(I-1,J)*(ALPHA*RD(I,J)+ALPHA1*RD(I-1,J))
      GO TO 730
  720 HA=HA+DL(I-1,J)*(ALPHA*RD(I-1,J)+ALPHA1*RD(I,J)) 
  730 IF(I-NR) 740,770,770 
  740 IF(FLAG(I+1,J).EQ.0) GO TO 770
      HC=T(I,J,2)*(RD(I+1,J)-RD(I,J))  
      IF(HC.GT.0.) HA=HA+HC
      IF(HC.LT.0.) HB=HB-HC
      IF(DL(I,J)) 750,770,760  
  750 HA=HA - DL(I,J)*(ALPHA*RD(I+1,J)+ALPHA1*RD(I,J)) 
      GO TO 770
  760 HB=HB+DL(I,J)*(ALPHA*RD(I,J)+ALPHA1*RD(I+1,J))
  770 IF(J-1) 810,810,780  
  780 IF(FLAG(I,J-1).EQ.0) GO TO 810
      HC=T(I,J-1,1)*(RD(I,J-1)-RD(I,J))
      IF(HC.GT.0.) HA=HA+HC
      IF(HC.LT.0.) HB=HB-HC
      IF(TOPAQ(I,J-1)) 790,810,800 
  790 HB=HB-TOPAQ(I,J-1)*(ALPHA*RD(I,J)+ALPHA1*RD(I,J-1))  
      GO TO 810
  800 HA=HA+TOPAQ(I,J-1)*(ALPHA*RD(I,J-1)+ALPHA1*RD(I,J))  
  810 IF(J-NC) 820,850,850 
  820 IF(FLAG(I,J+1).EQ.0) GO TO 850
      HC=T(I,J,1)*(RD(I,J+1)-RD(I,J))  
      IF(HC.GT.0.) HA=HA+HC
      IF(HC.LT.0.) HB=HB-HC
      IF(TOPAQ(I,J)) 830,850,840
  830 HA=HA - TOPAQ(I,J)*(ALPHA*RD(I,J+1)+ALPHA1*RD(I,J))  
      GO TO 850
  840 HB=HB + TOPAQ(I,J)*(ALPHA*RD(I,J)+ALPHA1*RD(I,J+1))  
  850 SUMP=SUMP + HA*DELTA 
      SUMR=SUMR+ HB * DELTA
  860 CONTINUE 
      SUMST=SUMST+HO(I,J)*R(I,J)
      SUMEN=SUMEN+H(I,J)*RD(I,J)
      SUMP=SUMP+Q(I,J)*DELTA*RD(I,J)
      SUMR=SUMR+RHG(I,J)*DELTA*SURFAC(I,J) 
  870 CONTINUE 
      DMAS=SUMEN-SUMST 
      SUMD=SUMD+DMAS
      SUMI=SUMI+SUMR
      SUMO=SUMO+SUMP
      SUMER=DMAS+SUMP-SUMR 
      SUME=SUME+SUMER  
      IF (NSMAL.EQ.1.OR.IOPT(19).GT.0) WRITE (OUT,1360)
      WRITE (OUT,1370) NSMAL,ITER,DELTA,SUMR,SUMP,DMAS,SUMER
      IF (IOPT(19).GT.0) GO TO 880 
      GO TO 900
  880 WRITE(OUT,1120) TITMOD,TITLE,QTITLE  
      WRITE (OUT,1390) NSMAL
C********************************************************************  
C      WRITE CONCENTRATIONS AT END OF TIME STEP
C********************************************************************  
      DO 890 I=1,NR
  890 WRITE (OUT,1210) I,(RD(I,J),J=1,NC)  
  900 CONTINUE 
      DO 910 I=1,NR
      DO 910 J=1,NC
      HO(I,J)=H(I,J)
  910 R(I,J)=RD(I,J)
      DELTA=DELTA*TIMACL
C********************************************************************  
C     END OF SMALL TIME STEP
C********************************************************************  
  920 CONTINUE 
      DELTA=DEL
      IF (IOPT(19).GT.0) WRITE (OUT,1360)  
      WRITE (OUT,1380) ISTEP,SUMI,SUMO,SUMD,SUME
C********************************************************************  
C     READ CONCENTRATIONS AT BEGINNING OF TIME STEP
C********************************************************************  
      REWIND IN9
      READ (IN9) R 
      IF (IOPT(19).GT.0) GO TO 940 
      IF (IOPT(9).LT.1) GO TO 940  
C********************************************************************  
C     WRITE ENDING CONCENTRATIONS  
C********************************************************************  
      WRITE(OUT,1120) TITMOD,TITLE,QTITLE  
      WRITE (OUT,1290) ISTEP
      DO 930 I=1,NR
  930 WRITE (OUT,1210) I,(RD(I,J),J=1,NC)  
C********************************************************************  
C     PLOT CONTOUR MAP OF CONCENTRATIONS
C********************************************************************  
  940 IF(IOPT(10).GT.0) CALL QPLOTH(NROW,NCOL,FLAG,RD,QTITLE,3)
      IF (IOPT(11).LT.1) GO TO 970 
C********************************************************************  
C     LIST QUALITY CHANGES DURING THIS TIME STEP
C********************************************************************  
      WRITE(OUT,1120) TITMOD,TITLE,QTITLE  
      WRITE (OUT,1300) ISTEP
      DO 960 I=1,NR
      DO 950 J=1,NC
  950 B(J)=RD(I,J)-R(I,J)  
  960 WRITE (OUT,1210) I,(B(J),J=1,NC) 
  970 IF (IOPT(20).LT.1) GO TO 1000
C********************************************************************  
C     LIST CHANGES IN CONCENTRATIONS THROUGH THIS STEP 
C********************************************************************  
      WRITE(OUT,1120) TITMOD,TITLE,QTITLE  
      WRITE (OUT,1310) ISTEP
      DO 990 I=1,NR
      DO 980 J=1,NC
  980 B(J)=RD(I,J)-HBEGN(I,J)  
  990 WRITE (OUT,1210) I,(B(J),J=1,NC) 
C********************************************************************  
C     PLOT QUALITY CHANGES DURING THIS TIME STEP
C********************************************************************  
 1000 IF(IOPT(12).GT.0) CALL QPLOTS(NROW,NCOL,FLAG,RD,R,QTITLE,5)  
C********************************************************************  
C     PLOT QUALITY CHANGES THROUGH THIS TIME STEP  
C********************************************************************  
      IF(IOPT(13).GT.0) CALL QPLOTS(NROW,NCOL ,FLAG,RD,HBEGN,QTITLE,6) 
      IF (IOPT(14).LT.1) GO TO 1080
C********************************************************************  
C     READ OBSERVED CONCENTRATIONS 
C********************************************************************  
      DO 1010 I=1,20
 1010 FMT(I)=VFMT(I,4) 
      IF(IOPT(14).LT.5) GO TO 1020 
      READ (IN8,1160) FMT  
      WRITE (OUT,1400) (FMT(I),I=1,10) 
 1020 DO 1030 I=1,NR
 1030 READ (IN8,FMT) (R(I,J),J=1,NC)
C********************************************************************  
C     LIST SIMULATED AND MEASURED CONCENTRATIONS
C     AND SIMULATION ERRORS
C********************************************************************  
      WRITE(OUT,1120) TITMOD,TITLE,QTITLE  
      WRITE (OUT,1130) ISTEP
      DO 1070 I=1,NR
      DO 1050 J=1,NC
      B(J)=0.  
      IFL=FLAG(I,J)+1  
      GO TO (1050,1040,1040,1050), IFL 
 1040 B(J)=RD(I,J)-R(I,J)  
 1050 CONTINUE 
      JST=1
 1060 JEND=JST+9
      JEND=AMIN0(JEND,NC)  
      WRITE (OUT,1200) 
      WRITE (OUT,1200) I,(RD(I,J),J=JST,JEND)  
      WRITE (OUT,1190) (R(I,J),J=JST,JEND) 
      WRITE (OUT,1190) (B(J),J=JST,JEND)
      JST=JEND+1
      IF (JST.GT.NC) GO TO 1070
      GO TO 1060
 1070 CONTINUE 
C********************************************************************  
C     PRINT MAP OF SIMULATION ERRORS
C********************************************************************  
      CALL QPLOTS(NROW,NCOL,FLAG,RD,R,QTITLE,4)
 1080 CONTINUE 
      DO 1090 J=1,NC
      DO 1090 I=1,NR
 1090 R(I,J)=RD(I,J)
C********************************************************************  
C     SAVE QUALTIY COEFFICIENTS ON 'IN9'
C********************************************************************  
      REWIND IN9
      WRITE (IN9) ((R(I,J),RD(I,J),P(I,J,1),P(I,J,2),SURFAC(I,J),HBEGN(I
     1,J),SF1(I,J),I=1,NR),J=1,NC) 
      WRITE (IN9) H,HO 
C********************************************************************  
C     READ HYDRAULIC SIMULATION COEFFICEINTS FROM 'IN7'
C********************************************************************  
      REWIND IN7
      READ(IN7)R,RD,P,T,SURFAC,HBEGN,DL,TOPAQ,SF1  
      READ (IN7) H,HO  
      RETURN
C********************************************************************  
C  
C  
 1100 FORMAT (T20,'NUMBER OF SMALL TIME STEPS IS',I5/T20,'FIRST STEP LEN
     1GTH IS',F10.4,' DAYS')
 1110 FORMAT(30I1,2F10.0)  
 1120 FORMAT(1H1,T25,20A4//T25,20A4/T25,20A4/) 
 1130 FORMAT (T10,'FOR TIME STEP ',I5,T35,'SIMULATED CONCENTRATIONS'/T35
     1,'MEASURED CONCENTRATIONS'/T35,'SIMULATION ERRORS'/) 
 1140 FORMAT (T20,'FOR SIMULATION STEP',I4/T20,'CONVEGENCE',' CRITERION
     1=',F10.3/T20,'ALPHA =',F10.3)
 1150 FORMAT (1H0,T10,'OPTION',I4,' IN EFFECT')
 1160 FORMAT (20A4)
 1190 FORMAT (6X,10F10.2)  
 1200 FORMAT (1H0,I5,10F10.2)  
 1210 FORMAT (1H0,I5,10F10.2/(6X,10F10.2)) 
 1240 FORMAT (T21,I3,4X,I3,3X,I3,5X,I3,2G19.4) 
 1290 FORMAT (1H0,T20,'QUALITY VALUES AT END OF SIMULATION'' PERIOD',I4/
     1)
 1300 FORMAT (1H0,T20,'QUALITY CHANGES DURING SIMULATION',' PERIOD',I4/)
 1310 FORMAT (1H0,T20,'QUALITY CHANGES THROUGH SIMULATION PERIOD',I4/) 
 1320 FORMAT (1H0,T20,'NUMBER OF ITERATIONS =',I5/)
 1360 FORMAT (1H0,T4,'STEP',T13,'ITERATIONS',T29,'STEP',T46,'MASS',T61,'
     1MASS',T76,'INCREASE OF',T101,'MASS'/T28,'LENGTH',T47,'IN',T62,'OUT
     2',T76,'STORED MASS',T99,'RESIDUAL'/) 
 1370 FORMAT (I7,T16,I3,T26,F8.2,T39,E14.5,E16.5,T75,E14.5,T96,E14.5)  
 1380 FORMAT (1H0,T4,'TOTALS THROUGH MAJOR STEP',I5,T39,E14.5,E16.5,T75,
     1E14.5,T96,E14.5) 
 1390 FORMAT (1H0,T20,'QUALITY VALUES AT END OF SMALL STEP',I5/)
 1400 FORMAT (T70,'FORMAT IS',T80,10A4/)
      END  
